import { __values, __decorate, __param } from 'tslib';
import { Inject, PLATFORM_ID, ɵɵdefineInjectable, ɵɵinject, Injectable } from '@angular/core';
import { isPlatformServer } from '@angular/common';

var Angular2MaterializeV1Service = /** @class */ (function () {
    // tslint:disable-next-line:ban-types
    function Angular2MaterializeV1Service(platformId) {
        this.platformId = platformId;
    }
    Angular2MaterializeV1Service_1 = Angular2MaterializeV1Service;
    Angular2MaterializeV1Service.carouselMouseOverTouchStart = function () {
        var instance = M.Carousel.getInstance(this);
        if (!instance) {
            return;
        }
        if (instance.autoScrollIntervalId) {
            window.clearInterval(instance.autoScrollIntervalId);
            instance.autoScrollIntervalId = undefined;
        }
    };
    Angular2MaterializeV1Service.carouselMouseOutTouchEnd = function () {
        var instance = M.Carousel.getInstance(this);
        if (!instance) {
            return;
        }
        if (!instance.autoScrollIntervalId) {
            instance.autoScrollIntervalId = window.setInterval(function () {
                instance.next();
            }, instance.options.autoScroll);
        }
    };
    Angular2MaterializeV1Service.getElements = function (elements) {
        if (elements.charAt(0) === '#') {
            elements = elements.replace('#', '');
            return document.getElementById(elements);
        }
        return document.querySelectorAll(elements);
    };
    Angular2MaterializeV1Service.removeAutoScroll = function (instance) {
        if (instance.autoScrollIntervalId) {
            window.clearInterval(instance.autoScrollIntervalId);
            instance.autoScrollIntervalId = undefined;
        }
        instance.el.removeEventListener('mouseover', Angular2MaterializeV1Service_1.carouselMouseOverTouchStart);
        instance.el.removeEventListener('mouseleave', Angular2MaterializeV1Service_1.carouselMouseOutTouchEnd);
        instance.el.removeEventListener('touchstart', Angular2MaterializeV1Service_1.carouselMouseOverTouchStart);
        instance.el.removeEventListener('touchend', Angular2MaterializeV1Service_1.carouselMouseOutTouchEnd);
    };
    Angular2MaterializeV1Service.prototype.addAutoScroll = function (instance) {
        if (!instance.options.autoScroll) {
            return;
        }
        instance.autoScrollIntervalId = window.setInterval(function () {
            instance.next();
        }, instance.options.autoScroll);
        instance.el.addEventListener('mouseover', Angular2MaterializeV1Service_1.carouselMouseOverTouchStart, { passive: true });
        instance.el.addEventListener('mouseleave', Angular2MaterializeV1Service_1.carouselMouseOutTouchEnd, { passive: true });
        instance.el.addEventListener('touchstart', Angular2MaterializeV1Service_1.carouselMouseOverTouchStart, { passive: true });
        instance.el.addEventListener('touchend', Angular2MaterializeV1Service_1.carouselMouseOutTouchEnd, { passive: true });
    };
    Angular2MaterializeV1Service.prototype.autoInit = function () {
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.AutoInit();
    };
    Angular2MaterializeV1Service.prototype.destroyCarousel = function (instances) {
        var e_1, _a;
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        if (Array.isArray(instances)) {
            try {
                for (var instances_1 = __values(instances), instances_1_1 = instances_1.next(); !instances_1_1.done; instances_1_1 = instances_1.next()) {
                    var instance = instances_1_1.value;
                    Angular2MaterializeV1Service_1.removeAutoScroll(instance);
                    instance.destroy();
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (instances_1_1 && !instances_1_1.done && (_a = instances_1.return)) _a.call(instances_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
        }
        else {
            Angular2MaterializeV1Service_1.removeAutoScroll(instances);
            instances.destroy();
        }
    };
    Angular2MaterializeV1Service.prototype.dismissAllToasts = function () {
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.Toast.dismissAll();
    };
    Angular2MaterializeV1Service.prototype.initAutocomplete = function (elements, options) {
        if (options === void 0) { options = {}; }
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.Autocomplete.init(Angular2MaterializeV1Service_1.getElements(elements), options);
    };
    Angular2MaterializeV1Service.prototype.initCarousel = function (elements, options) {
        var e_2, _a;
        if (options === void 0) { options = {}; }
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        var instances = M.Carousel.init(Angular2MaterializeV1Service_1.getElements(elements), options);
        if (Array.isArray(instances)) {
            try {
                for (var instances_2 = __values(instances), instances_2_1 = instances_2.next(); !instances_2_1.done; instances_2_1 = instances_2.next()) {
                    var instance = instances_2_1.value;
                    this.addAutoScroll(instance);
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (instances_2_1 && !instances_2_1.done && (_a = instances_2.return)) _a.call(instances_2);
                }
                finally { if (e_2) throw e_2.error; }
            }
        }
        else {
            this.addAutoScroll(instances);
        }
        return instances;
    };
    Angular2MaterializeV1Service.prototype.initCharacterCount = function (elements) {
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.CharacterCounter.init(Angular2MaterializeV1Service_1.getElements(elements));
    };
    Angular2MaterializeV1Service.prototype.initChips = function (elements, options) {
        if (options === void 0) { options = {}; }
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.Chips.init(Angular2MaterializeV1Service_1.getElements(elements), options);
    };
    Angular2MaterializeV1Service.prototype.initCollapsible = function (elements, options) {
        if (options === void 0) { options = {}; }
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.Collapsible.init(Angular2MaterializeV1Service_1.getElements(elements), options);
    };
    Angular2MaterializeV1Service.prototype.initDatepicker = function (elements, options) {
        if (options === void 0) { options = {}; }
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.Datepicker.init(Angular2MaterializeV1Service_1.getElements(elements), options);
    };
    Angular2MaterializeV1Service.prototype.initDropdown = function (elements, options) {
        if (options === void 0) { options = {}; }
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.Dropdown.init(Angular2MaterializeV1Service_1.getElements(elements), options);
    };
    Angular2MaterializeV1Service.prototype.initFloatingActionButton = function (elements, options) {
        if (options === void 0) { options = {}; }
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.FloatingActionButton.init(Angular2MaterializeV1Service_1.getElements(elements), options);
    };
    Angular2MaterializeV1Service.prototype.initMaterialbox = function (elements, options) {
        if (options === void 0) { options = {}; }
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.Materialbox.init(Angular2MaterializeV1Service_1.getElements(elements), options);
    };
    Angular2MaterializeV1Service.prototype.initModal = function (elements, options) {
        if (options === void 0) { options = {}; }
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.Modal.init(Angular2MaterializeV1Service_1.getElements(elements), options);
    };
    Angular2MaterializeV1Service.prototype.initParallax = function (elements, options) {
        if (options === void 0) { options = {}; }
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.Parallax.init(Angular2MaterializeV1Service_1.getElements(elements), options);
    };
    Angular2MaterializeV1Service.prototype.initPushpin = function (elements, options) {
        if (options === void 0) { options = {}; }
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.Pushpin.init(Angular2MaterializeV1Service_1.getElements(elements), options);
    };
    Angular2MaterializeV1Service.prototype.initScrollSpy = function (elements, options) {
        if (options === void 0) { options = {}; }
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.ScrollSpy.init(Angular2MaterializeV1Service_1.getElements(elements), options);
    };
    Angular2MaterializeV1Service.prototype.initSelect = function (elements, options) {
        if (options === void 0) { options = {}; }
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.FormSelect.init(Angular2MaterializeV1Service_1.getElements(elements), options);
    };
    Angular2MaterializeV1Service.prototype.initSidenav = function (elements, options) {
        if (options === void 0) { options = {}; }
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.Sidenav.init(Angular2MaterializeV1Service_1.getElements(elements), options);
    };
    Angular2MaterializeV1Service.prototype.initTabs = function (elements, options) {
        if (options === void 0) { options = {}; }
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.Tabs.init(Angular2MaterializeV1Service_1.getElements(elements), options);
    };
    Angular2MaterializeV1Service.prototype.initTapTarget = function (elements, options) {
        if (options === void 0) { options = {}; }
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.TapTarget.init(Angular2MaterializeV1Service_1.getElements(elements), options);
    };
    Angular2MaterializeV1Service.prototype.initTimepicker = function (elements, options) {
        if (options === void 0) { options = {}; }
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.Timepicker.init(Angular2MaterializeV1Service_1.getElements(elements), options);
    };
    Angular2MaterializeV1Service.prototype.initTooltip = function (elements, options) {
        if (options === void 0) { options = {}; }
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.Tooltip.init(Angular2MaterializeV1Service_1.getElements(elements), options);
    };
    Angular2MaterializeV1Service.prototype.toast = function (options) {
        if (options === void 0) { options = {}; }
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.toast(options);
    };
    Angular2MaterializeV1Service.prototype.updateTextFields = function () {
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.updateTextFields();
    };
    var Angular2MaterializeV1Service_1;
    Angular2MaterializeV1Service.ctorParameters = function () { return [
        { type: Object, decorators: [{ type: Inject, args: [PLATFORM_ID,] }] }
    ]; };
    Angular2MaterializeV1Service.ɵprov = ɵɵdefineInjectable({ factory: function Angular2MaterializeV1Service_Factory() { return new Angular2MaterializeV1Service(ɵɵinject(PLATFORM_ID)); }, token: Angular2MaterializeV1Service, providedIn: "root" });
    Angular2MaterializeV1Service = Angular2MaterializeV1Service_1 = __decorate([
        Injectable({
            providedIn: 'root'
        }),
        __param(0, Inject(PLATFORM_ID))
    ], Angular2MaterializeV1Service);
    return Angular2MaterializeV1Service;
}());

/*
 * Public API Surface of angular2-materialize-v1
 */

/**
 * Generated bundle index. Do not edit.
 */

export { Angular2MaterializeV1Service };
//# sourceMappingURL=angular2-materialize-v1.js.map
