import * as IOptions from './IOptions';
export interface IAutocomplete {
    open: () => void;
    close: () => void;
    selectOption: (liElement: HTMLElement) => void;
    updateData: (data: any) => void;
    destroy: () => void;
    el: HTMLElement;
    options: IOptions.IAutocompleteOptions;
    isOpen: boolean;
    count: number;
    activeIndex: number;
    dropdown: IDropdown;
}
export interface ICarousel {
    next: (numTimes?: number) => void;
    prev: (numTimes?: number) => void;
    set: (nthSlide?: number) => void;
    destroy: () => void;
    el: HTMLElement;
    options: IOptions.ICarouselOptions;
    pressed: boolean;
    dragged: boolean;
    center: number;
}
export interface ICharacterCounter {
    el: HTMLElement;
    isInvalid: boolean;
    isValidLength: boolean;
}
export interface IChips {
    addChip: (newChip: {
        tag: string;
        image?: string;
    }) => void;
    deleteChip: (nthChip: number) => void;
    selectChip: (nthChip: number) => void;
    el: HTMLElement;
    options: IOptions.IChipsOptions;
    chipsData: Array<{
        tag: string;
        image?: string;
    }>;
    hasAutocomplete: boolean;
    autocomplete: IAutocomplete;
}
export interface ICollapsible {
    open: (nthSection: number) => void;
    close: (nthSection: number) => void;
    destroy: () => void;
    el: HTMLElement;
    options: IOptions.ICollapsibleOptions;
}
export interface IDatepicker {
    open: () => void;
    close: () => void;
    toString: () => string;
    setDate: (date?: Date) => void;
    gotoDate: (date: Date) => void;
    destroy: () => void;
    el: HTMLElement;
    options: IOptions.IDatepickerOptions;
    isOpen: boolean;
    date: Date;
}
export interface IDropdown {
    open: () => void;
    close: () => void;
    recalculateDimensions: () => void;
    destroy: () => void;
    el: HTMLElement;
    options: IOptions.IDropdownOptions;
    id: string;
    dropdownEl: HTMLElement;
    isOpen: boolean;
    isScrollable: boolean;
    focusedIndex: number;
}
export interface IFloatingActionButton {
    open: () => void;
    close: () => void;
    destroy: () => void;
    el: HTMLElement;
    options: IOptions.IFloatingActionButtonOptions;
    isOpen: boolean;
}
export interface IMaterialbox {
    open: () => void;
    close: () => void;
    destroy: () => void;
    el: HTMLElement;
    options: IOptions.IMaterialboxOptions;
    overlayActive: boolean;
    doneAnimating: boolean;
    caption: string;
    originalWidth: number;
    originalHeight: number;
}
export interface IModal {
    open: () => void;
    close: () => void;
    destroy: () => void;
    el: HTMLElement;
    options: IOptions.IModalOptions;
    isOpen: boolean;
    id: string;
}
export interface IParallax {
    destroy: () => void;
    el: HTMLElement;
    options: IOptions.IParallaxOptions;
}
export interface IPushpin {
    destroy: () => void;
    el: HTMLElement;
    options: IOptions.IPushpinOptions;
    originalOffset: number;
}
export interface IScrollSpy {
    destroy: () => void;
    el: HTMLElement;
    options: IOptions.IScrollSpyOptions;
}
export interface ISelect {
    getSelectedValues: () => Array<string>;
    destroy: () => void;
    el: HTMLElement;
    options: IOptions.ISelectOptions;
    isMultiple: boolean;
    wrapper: HTMLElement;
    dropdownOptions: HTMLElement;
    input: HTMLElement;
    dropdown: IDropdown;
}
export interface ISidenav {
    open: () => void;
    close: () => void;
    destroy: () => void;
    el: HTMLElement;
    options: IOptions.ISidenavOptions;
    isOpen: boolean;
    isFixed: boolean;
    isDragged: boolean;
}
export interface ITabs {
    el: HTMLElement;
    options: IOptions.ITabsOptions;
}
export interface ITapTarget {
    open: () => void;
    close: () => void;
    destroy: () => void;
    el: HTMLElement;
    options: IOptions.ITapTargetOptions;
    isOpen: boolean;
}
export interface ITimepicker {
    open: () => void;
    close: () => void;
    showView: (view: string | 'hours' | 'minutes') => void;
    destroy: () => void;
    el: HTMLElement;
    options: IOptions.ITimepickerOptions;
    isOpen: boolean;
    time: string;
}
export interface IToast {
    dismiss: () => void;
    el: HTMLElement;
    options: IOptions.IToastOptions;
    panning: boolean;
    timeRemaining: number;
}
export interface ITooltip {
    open: () => void;
    close: () => void;
    destroy: () => void;
    el: HTMLElement;
    options: IOptions.ITooltipOptions;
    isOpen: boolean;
    isHovered: boolean;
}
